- Main Page
- Classes
- Files
- Directories
- Examples

- Class List
- Class Hierarchy
- Class Members

Classes | Public Member Functions | Protected Types | Protected Attributes

# FbxEmitter Class Reference

Search for all occurrences

## Detailed Description

Base class to emit event with the specified event type.

The event type could be a specific class which derived from FbxEvent. Please read FbxEmitter::Emit() for more details. Event emitter contains a list of event handlers. FBX object could be used as emitter, since FbxObject is derived from FbxEmitter. Before using emitter to emit an event, one or more event handlers must be added to the handlers list of current emitter. In other words, it's "bind event handlers to emitter". There are two ways to bind event handlers to emitter.

- 1. If you already got an event handler and would like to bind it to current emitter, please call FbxEmitter::AddListener().
- 2. Or you can create an event listener first and then call FbxListener::Bind(). It will create an event handler automatically and bind the handler to the specified emitter. It's similar to unbind or remove an even handler. For more details,
  See also:
    FbxEmitter::RemoveListener()
    FbxListener::Unbind()
  Note:
    Only Emit() is thread-safe.
  Remarks:
    An object(emitter) can emit a certain type of event, the plug-in(listener) who are listening to that type of event, will receive a signal and take action to process the event data.
  The whole process of event is:
- 1. Create an emitter and a listener, then bind them together via the same event handler.
- 2. Emitter can emit an event at certain conditions. The event could be handled by event handler.
- 3. Once an event is emitted, the listener to this event will receive a signal.
- 4. And then the listener could process the event data according to the types of event, by calling event handler.
  Note:
    The event data is process by the callback function of event handler.
  See also:
    FbxListener FbxEventHandler FbxEvent FbxEventBase

Definition at line 54 of file fbxemitter.h.

`#include <fbxemitter.h>`

Inheritance diagram for FbxEmitter:
[legend]

List of all members.

## Classes
struct | Data
## Public Member Functions
| FbxEmitter ()
| Constructor.
| ~FbxEmitter ()
| Destructor.
void | AddListener (FbxEventHandler &pHandler)
| The specified event handler will be added to the handlers list of current emitter.
void | RemoveListener (FbxEventHandler &pHandler)
| The specified event handler will be removed from the handlers list of current emitter.
template<typename EventType >
void | Emit (const EventType &pEvent) const
| Emit an event with the specified the event type.
## Protected Types
typedef FbxIntrusiveList < FbxEventHandler, FbxEventHandler::eEmitter > | EventHandlerList
## Protected Attributes
Data * | mData

## Member Typedef Documentation

typedef FbxIntrusiveList<FbxEventHandler, FbxEventHandler::eEmitter> EventHandlerList `[protected]`

Search for all occurrences

Definition at line 113 of file fbxemitter.h.

## Constructor & Destructor Documentation

FbxEmitter | ( |  | ) |

Constructor.

~FbxEmitter | ( |  | ) |

Destructor.

## Member Function Documentation

void AddListener | ( | FbxEventHandler & | pHandler | ) |

Search for all occurrences

The specified event handler will be added to the handlers list of current emitter.

Bind the specified event handler to current emitter actually.

Note:
  This is not a thread-safe method!

Parameters:

  pHandler | the event handler will be added to the handlers list of current emitter.

void RemoveListener | ( | FbxEventHandler & | pHandler | ) |

Search for all occurrences

The specified event handler will be removed from the handlers list of current emitter.

Note:
  This is not a thread-safe method!

Parameters:

  pHandler | the event handler will be removed from the handlers list of current emitter.

void Emit | ( | const EventType & | pEvent | ) | const `[inline]`

Search for all occurrences

Emit an event with the specified the event type.

One the event is emitted, the listener to this event will receive a signal.

Note:
  This is a thread-safe method!

Parameters:

  pEvent | specify the event type to emit. pEvent could be a specific class which derived from FbxEvent, such as FbxObjectPropertyChanged.

Remarks:
  For example:

       FbxObject::Emit(FbxObjectPropertyChanged(*pProperty));

See also:
  FbxEventBase FbxObjectPropertyChanged FbxEventReferencedDocument FbxEventPostExport
  FbxEventPostImport FbxEventPreExport FbxEventPreImport FbxEventPopulateSystemLibrary

Definition at line 88 of file fbxemitter.h.

        {
            if ( mData )
            {
                EventHandlerList::iterator itBegin = mData->mEventHandler.Begin();
                EventHandlerList::iterator itEnd = mData->mEventHandler.End();
                for (EventHandlerList::iterator it = itBegin; it!=itEnd; ++it)
                {
                    if ((*it).GetHandlerEventType() == pEvent.GetTypeId())
                        (*it).FunctionCall(pEvent);
                }
            }
        }

## Member Data Documentation

Data* mData `[protected]`

Search for all occurrences

Reimplemented in FbxCache.

Definition at line 120 of file fbxemitter.h.

The documentation for this class was generated from the following file:

- fbxsdk/core/fbxemitter.h

FbxEmitter FbxEmitter FbxEmitter FbxEmitter FbxEmitter FbxEmitter FbxEmitter FbxEmitter FbxEmitter FbxEmitter
FbxEmitter FbxEmitter FbxEmitter FbxEmitter FbxEmitter FbxEmitter FbxEmitter FbxEmitter FbxEmitter FbxEmitter